## nheko 0.8.0+really0.7.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

option(APPVEYOR_BUILD "Build on appveyor" OFF)
option(CI_BUILD "Set when building in CI. Enables -Werror where possible" OFF)
option(ASAN "Compile with address sanitizers" OFF)
option(QML_DEBUGGING "Enable qml debugging" OFF)

set(
	CMAKE_TOOLCHAIN_FILE "${CMAKE_CURRENT_LIST_DIR}/toolchain.cmake"
	CACHE
	FILEPATH "Default toolchain"
	)
set(CMAKE_CXX_STANDARD 17 CACHE STRING "C++ standard")
set(CMAKE_CXX_STANDARD_REQUIRED ON CACHE BOOL "Require C++ standard to be supported")
set(CMAKE_POSITION_INDEPENDENT_CODE ON CACHE BOOL "compile as PIC by default")

option(HUNTER_ENABLED "Enable Hunter package manager" OFF)
include("cmake/HunterGate.cmake")
HunterGate(
	URL "https://github.com/cpp-pm/hunter/archive/v0.23.244.tar.gz"
	SHA1 "2c0f491fd0b80f7b09e3d21adb97237161ef9835"
	LOCAL
	)

option(USE_BUNDLED_BOOST "Use the bundled version of Boost." ${HUNTER_ENABLED})
option(USE_BUNDLED_SPDLOG "Use the bundled version of spdlog."
	${HUNTER_ENABLED})
option(USE_BUNDLED_OLM "Use the bundled version of libolm." ${HUNTER_ENABLED})
option(USE_BUNDLED_GTEST "Use the bundled version of Google Test."
	${HUNTER_ENABLED})
option(USE_BUNDLED_CMARK "Use the bundled version of cmark."
	${HUNTER_ENABLED})
option(USE_BUNDLED_JSON "Use the bundled version of nlohmann json."
	${HUNTER_ENABLED})
option(USE_BUNDLED_OPENSSL "Use the bundled version of OpenSSL."
	${HUNTER_ENABLED})
option(USE_BUNDLED_MTXCLIENT "Use the bundled version of the Matrix Client library." ${HUNTER_ENABLED})
option(USE_BUNDLED_SODIUM "Use the bundled version of libsodium."
	${HUNTER_ENABLED})
option(USE_BUNDLED_LMDB "Use the bundled version of lmdb."
	${HUNTER_ENABLED})
option(USE_BUNDLED_LMDBXX "Use the bundled version of lmdb++."
	${HUNTER_ENABLED})
option(USE_BUNDLED_TWEENY "Use the bundled version of tweeny."
	${HUNTER_ENABLED})

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

if(${CMAKE_VERSION} VERSION_LESS "3.14.0")
	message("Adding FetchContent_MakeAvailable")
	# from cmakes sources
	macro(FetchContent_MakeAvailable)

		foreach(contentName IN ITEMS ${ARGV})
			string(TOLOWER ${contentName} contentNameLower)
			FetchContent_GetProperties(${contentName})
			if(NOT ${contentNameLower}_POPULATED)
				FetchContent_Populate(${contentName})

				# Only try to call add_subdirectory() if the populated content
				# can be treated that way. Protecting the call with the check
				# allows this function to be used for projects that just want
				# to ensure the content exists, such as to provide content at
				# a known location.
				if(EXISTS ${${contentNameLower}_SOURCE_DIR}/CMakeLists.txt)
					add_subdirectory(${${contentNameLower}_SOURCE_DIR}
						${${contentNameLower}_BINARY_DIR})
				endif()
			endif()
		endforeach()

	endmacro()
endif()

include(GNUInstallDirs)

# Include Qt basic functions
include(QtCommon)

project(nheko LANGUAGES CXX C)
set(CPACK_PACKAGE_VERSION_MAJOR "0")
set(CPACK_PACKAGE_VERSION_MINOR "7")
set(CPACK_PACKAGE_VERSION_PATCH "2")
set(PROJECT_VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH})

# Set PROJECT_VERSION_PATCH & PROJECT_VERSION_TWEAK to 0 if not present
# Needed by add_project_meta.
fix_project_version()

# Set additional project information
set(COMPANY "Nheko")
set(COPYRIGHT "Copyright (c) 2019 Nheko Contributors")
set(IDENTIFIER "com.github.mujx.nheko")

add_project_meta(META_FILES_TO_INCLUDE)

if(NOT MSVC AND NOT APPLE)
	set(THREADS_PREFER_PTHREAD_FLAG ON)
	find_package(Threads REQUIRED)
endif()

if (BUILD_DOCS)
	find_package(Doxygen)

	if (DOXYGEN_FOUND)
		set(DOXYGEN_IN ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Doxyfile.in)
		set(DOXYGEN_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

		configure_file(${DOXYGEN_IN} ${DOXYGEN_OUT})

		add_custom_target(docs ALL
			COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_OUT}
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			COMMENT "Generating API documentation with Doxygen"
			VERBATIM )
	else (DOXYGEN_FOUND)
		message("Doxygen need to be installed to generate the doxygen documentation")
	endif (DOXYGEN_FOUND)
endif()


#
# LMDB
#
#include(LMDB)
if(USE_BUNDLED_LMDB)
	hunter_add_package(lmdb)
	find_package(liblmdb CONFIG REQUIRED)
else()
	find_package(LMDB)
endif()

#
# Discover Qt dependencies.
#
find_package(Qt5 COMPONENTS Core Widgets LinguistTools Concurrent Svg Multimedia Qml QuickControls2 QuickWidgets REQUIRED)
find_package(Qt5QuickCompiler)
find_package(Qt5DBus)

if (APPLE)
	find_package(Qt5MacExtras REQUIRED)
endif(APPLE)

if (Qt5Widgets_FOUND)
	if (Qt5Widgets_VERSION VERSION_LESS 5.9.0)
		message(STATUS "Qt version ${Qt5Widgets_VERSION}")
		message(WARNING "Minimum supported Qt5 version is 5.9!")
	endif()
endif(Qt5Widgets_FOUND)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
if(NOT MSVC)
	set(
		CMAKE_CXX_FLAGS
		"${CMAKE_CXX_FLAGS} \
		-Wall \
		-Wextra \
		-pipe \
		-pedantic \
		-fsized-deallocation \
		-fdiagnostics-color=always \
		-Wunreachable-code \
		-std=c++17"
		)
	if (NOT CMAKE_COMPILER_IS_GNUCXX)
		# -Wshadow is buggy and broken in GCC, so do not enable it.
		# see https://gcc.gnu.org/bugzilla/show_bug.cgi?id=79328
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow")
	endif()
endif()

if (MSVC)
	set(
		CMAKE_CXX_FLAGS
		"${CMAKE_CXX_FLAGS} /bigobj"
		)
endif()

if(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))
	set(CMAKE_BUILD_TYPE "Debug" CACHE STRING
		"Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
		FORCE)
	message("Setting build type to '${CMAKE_BUILD_TYPE}'")
else(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))
	message("Build type set to '${CMAKE_BUILD_TYPE}'")
endif(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))

set(SPDLOG_DEBUG_ON false)

# Windows doesn't handle CMAKE_BUILD_TYPE.
if(NOT WIN32)
	if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
		set(SPDLOG_DEBUG_ON true)
	else()
		set(SPDLOG_DEBUG_ON false)
	endif()
endif()

find_program(GIT git)
if(GIT)
	execute_process(
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		COMMAND ${GIT} rev-parse --short HEAD
		OUTPUT_VARIABLE GIT_OUT OUTPUT_STRIP_TRAILING_WHITESPACE
		)
	if(GIT_OUT)
		set(CPACK_PACKAGE_VERSION_PATCH "${CPACK_PACKAGE_VERSION_PATCH}-${GIT_OUT}")
	else()
		set(CPACK_PACKAGE_VERSION_PATCH "${CPACK_PACKAGE_VERSION_PATCH}")
	endif()
endif(GIT)

set(CPACK_PACKAGE_VERSION ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH})
set(PROJECT_VERSION ${CPACK_PACKAGE_VERSION})

message(STATUS "Version: ${PROJECT_VERSION}")

cmake_host_system_information(RESULT BUILD_HOST QUERY HOSTNAME)
set(BUILD_USER $ENV{USER})
configure_file(cmake/nheko.h config/nheko.h)


#
# Declare source and header files.
#
set(SRC_FILES
	# Dialogs
	src/dialogs/CreateRoom.cpp
	src/dialogs/FallbackAuth.cpp
	src/dialogs/ImageOverlay.cpp
	src/dialogs/InviteUsers.cpp
	src/dialogs/JoinRoom.cpp
	src/dialogs/LeaveRoom.cpp
	src/dialogs/Logout.cpp
	src/dialogs/MemberList.cpp
	src/dialogs/PreviewUploadOverlay.cpp
	src/dialogs/ReCaptcha.cpp
	src/dialogs/ReadReceipts.cpp
	src/dialogs/RoomSettings.cpp
	src/dialogs/UserProfile.cpp

	# Emoji
	src/emoji/Category.cpp
	src/emoji/EmojiModel.cpp
	src/emoji/ItemDelegate.cpp
	src/emoji/Panel.cpp
	src/emoji/PickButton.cpp
	src/emoji/Provider.cpp
	src/emoji/Provider_new.cpp


	# Timeline
	src/timeline/ReactionsModel.cpp
	src/timeline/TimelineViewManager.cpp
	src/timeline/TimelineModel.cpp
	src/timeline/DelegateChooser.cpp

	# UI components
	src/ui/Avatar.cpp
	src/ui/Badge.cpp
	src/ui/DropShadow.cpp
	src/ui/LoadingIndicator.cpp
	src/ui/InfoMessage.cpp
	src/ui/FlatButton.cpp
	src/ui/FloatingButton.cpp
	src/ui/Label.cpp
	src/ui/OverlayModal.cpp
	src/ui/SnackBar.cpp
	src/ui/RaisedButton.cpp
	src/ui/Ripple.cpp
	src/ui/RippleOverlay.cpp
	src/ui/OverlayWidget.cpp
	src/ui/TextField.cpp
	src/ui/TextLabel.cpp
	src/ui/ToggleButton.cpp
	src/ui/Theme.cpp
	src/ui/ThemeManager.cpp

	src/AvatarProvider.cpp
	src/BlurhashProvider.cpp
	src/Cache.cpp
	src/ChatPage.cpp
	src/ColorImageProvider.cpp
	src/CommunitiesList.cpp
	src/CommunitiesListItem.cpp
	src/EventAccessors.cpp
	src/InviteeItem.cpp
	src/Logging.cpp
	src/LoginPage.cpp
	src/MainWindow.cpp
	src/MatrixClient.cpp
	src/MxcImageProvider.cpp
	src/Olm.cpp
	src/QuickSwitcher.cpp
	src/RegisterPage.cpp
	src/RoomInfoListItem.cpp
	src/RoomList.cpp
	src/SSOHandler.cpp
	src/SideBarActions.cpp
	src/Splitter.cpp
	src/TextInputWidget.cpp
	src/TopRoomBar.cpp
	src/TrayIcon.cpp
	src/UserInfoWidget.cpp
	src/UserSettingsPage.cpp
	src/Utils.cpp
	src/WelcomePage.cpp
	src/popups/PopupItem.cpp
	src/popups/SuggestionsPopup.cpp
	src/popups/UserMentions.cpp
	src/main.cpp

	third_party/blurhash/blurhash.cpp
	)


include(FeatureSummary)

if(USE_BUNDLED_BOOST)
	hunter_add_package(Boost COMPONENTS iostreams system thread)
endif()
find_package(Boost 1.70 REQUIRED
	COMPONENTS iostreams
	system
	thread)

if(USE_BUNDLED_OPENSSL)
	hunter_add_package(OpenSSL)
endif()
find_package(OpenSSL REQUIRED)
if(USE_BUNDLED_MTXCLIENT)
	include(FetchContent)
	set(BUILD_LIB_EXAMPLES OFF CACHE INTERNAL "")
	set(BUILD_LIB_TESTS OFF CACHE INTERNAL "")
	FetchContent_Declare(
		MatrixClient
		GIT_REPOSITORY https://github.com/Nheko-Reborn/mtxclient.git
		GIT_TAG        v0.3.1
		)
	FetchContent_MakeAvailable(MatrixClient)
else()
	find_package(MatrixClient 0.3.1 REQUIRED)
endif()
if(USE_BUNDLED_OLM)
	include(FetchContent)
	set(OLM_TESTS OFF CACHE INTERNAL "")
	FetchContent_Declare(
		Olm
		GIT_REPOSITORY https://gitlab.matrix.org/matrix-org/olm.git
		GIT_TAG        3.1.4
		)
	FetchContent_MakeAvailable(Olm)
else()
	find_package(Olm 3)
	set_package_properties(Olm PROPERTIES
		DESCRIPTION "An implementation of the Double Ratchet cryptographic ratchet"
		URL "https://git.matrix.org/git/olm/about/"
		TYPE REQUIRED
		)
endif()
if(USE_BUNDLED_SPDLOG)
	hunter_add_package(spdlog)
endif()
find_package(spdlog 1.0.0 CONFIG REQUIRED)

if(USE_BUNDLED_CMARK)
	include(FetchContent)
	FetchContent_Declare(
		cmark
		GIT_REPOSITORY https://github.com/commonmark/cmark.git
		GIT_TAG        242e277a661ec7e51f34dcaf86c1925d550b1498 #0.29.0 << doesn't work with fetch content yet
		CMAKE_ARGS     "CMARK_STATIC=ON CMARK_SHARED=OFF CMARK_TESTS=OFF CMARK_TESTS=OFF"
		)
	FetchContent_MakeAvailable(cmark)
	if (MSVC)
		add_library(cmark::cmark ALIAS libcmark)
	else()
		add_library(cmark::cmark ALIAS libcmark_static)
	endif()
else()
	find_package(cmark REQUIRED 0.29.0)
endif()

if(USE_BUNDLED_JSON)
	hunter_add_package(nlohmann_json)
endif()
find_package(nlohmann_json 3.2.0)
set_package_properties(nlohmann_json PROPERTIES
	DESCRIPTION "JSON for Modern C++, a C++11 header-only JSON class"
	URL "https://nlohmann.github.io/json/"
	TYPE REQUIRED
	)

if(USE_BUNDLED_LMDBXX)
	hunter_add_package(lmdbxx)
	find_package(lmdbxx CONFIG REQUIRED)
else()
	if(NOT LMDBXX_INCLUDE_DIR)
		find_path(LMDBXX_INCLUDE_DIR
			NAMES lmdb++.h
			PATHS /usr/include
			/usr/local/include
			$ENV{LIB_DIR}/include
			$ENV{LIB_DIR}/include/lmdbxx)

	endif()
	add_library(lmdbxx INTERFACE)
	target_include_directories(lmdbxx INTERFACE ${LMDBXX_INCLUDE_DIR})
	add_library(lmdbxx::lmdbxx ALIAS lmdbxx)
endif()

if(USE_BUNDLED_TWEENY)
	include(FetchContent)
	FetchContent_Declare(
		Tweeny
		GIT_REPOSITORY https://github.com/mobius3/tweeny.git
		GIT_TAG        6a5033372fe53c4c731c66c8a2d56261746cd85c #v3 <- v3 has unfixed warnings
		)
	FetchContent_MakeAvailable(Tweeny)
else()
	find_package(Tweeny REQUIRED)
endif()

# single instance functionality
set(QAPPLICATION_CLASS QApplication CACHE STRING "Inheritance class for SingleApplication")
add_subdirectory(third_party/SingleApplication-3.1.3.1/)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

qt5_wrap_cpp(MOC_HEADERS
	# Dialogs
	src/dialogs/CreateRoom.h
	src/dialogs/FallbackAuth.h
	src/dialogs/ImageOverlay.h
	src/dialogs/InviteUsers.h
	src/dialogs/JoinRoom.h
	src/dialogs/LeaveRoom.h
	src/dialogs/Logout.h
	src/dialogs/MemberList.h

=== Makefile ===
FILES=`find lib include tests examples -type f -type f \( -iname "*.cpp" -o -iname "*.hpp" \)`

SYNAPSE_IMAGE="matrixdotorg/synapse:v1.7.2"

DEPS_BUILD_DIR=.deps
DEPS_SOURCE_DIR=deps

help: ## This help message
	@grep -E '^[0-9a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}'
	@# Change the digit following by an 's' to adjust the width of the help text

third-party: ## Build & install third party dependencies
	@cmake -GNinja -H${DEPS_SOURCE_DIR} -B${DEPS_BUILD_DIR} -DCMAKE_BUILD_TYPE=Release -DUSE_BUNDLED_BOOST=OFF -DUSE_BUNDLED_JSON=OFF
	@cmake --build ${DEPS_BUILD_DIR}

debug: ## Create a debug build
	@cmake -GNinja -H. -Bbuild \
		-DCMAKE_BUILD_TYPE=Debug \
		-DCMAKE_EXPORT_COMPILE_COMMANDS=1 \
		-DOPENSSL_ROOT_DIR=/usr/local/opt/openssl \
		-DCMAKE_INSTALL_PREFIX=${DEPS_BUILD_DIR}/usr
	@cmake --build build

release: ## Create an optimized build
	@cmake -GNinja -H. -Bbuild \
		-DCMAKE_BUILD_TYPE=Release \
		-DOPENSSL_ROOT_DIR=/usr/local/opt/openssl \
		-DCMAKE_INSTALL_PREFIX=${DEPS_BUILD_DIR}/usr
	@cmake --build build

test: ## Run the tests
	@cd build/ && GTEST_COLOR=1 ctest --verbose

asan: ## Create a debug build using address sanitizers
	@cmake -GNinja -H. -Bbuild \
		-DCMAKE_BUILD_TYPE=Debug \
		-DOPENSSL_ROOT_DIR=/usr/local/opt/openssl \
		-DCMAKE_INSTALL_PREFIX=${DEPS_BUILD_DIR}/usr \
		-DASAN=1
	@cmake --build build

image:
	docker build -t mtxclient-dev .

synapse: ## Start a synapse instance on docker
	@mkdir -p data
	@chmod 0777 data
	@docker run -v `pwd`/data:/data --rm \
		-e SYNAPSE_SERVER_NAME=localhost -e SYNAPSE_REPORT_STATS=no ${SYNAPSE_IMAGE} generate
	@./.ci/adjust-config.sh
	@docker run -d \
		--name synapse \
		-p 443:8008 \
		-p 8448:8008 \
		-p 8008:8008 \
		-v `pwd`/data:/data ${SYNAPSE_IMAGE}
	@echo Waiting for synapse to start...
	@until curl -s -f -k https://localhost:443/_matrix/client/versions; do echo "Checking ..."; sleep 2; done
	@echo Register alice
	@docker exec synapse /bin/sh -c 'register_new_matrix_user --admin -u alice -p secret -c /data/homeserver.yaml https://localhost:8008'
	@echo Register bob
	@docker exec synapse /bin/sh -c 'register_new_matrix_user --admin -u bob -p secret -c /data/homeserver.yaml https://localhost:8008'
	@echo Register carl
	@docker exec synapse /bin/sh -c 'register_new_matrix_user --admin -u carl -p secret -c /data/homeserver.yaml https://localhost:8008'

stop-synapse: ## Stop any running instance of synapse
	@rm -rf ./data/*
	@docker rm -f synapse 2>&1>/dev/null

restart: stop-synapse synapse

lint: ## Run clang-format on the source code
	@clang-format -i ${FILES} && git diff --exit-code

clean: ## Delete the build directory
	rm -rf build

=== examples/CMakeLists.txt ===
if(USE_BUNDLED_SPDLOG)
	hunter_add_package(spdlog)
endif()
find_package(spdlog 1.0.0 CONFIG)
set_package_properties(spdlog PROPERTIES
    DESCRIPTION "Very fast, header only, C++ logging library"
    URL "https://github.com/gabime/spdlog"
    TYPE REQUIRED
)

include_directories(../tests)

add_executable(room_feed room_feed.cpp)
target_link_libraries(room_feed MatrixClient::MatrixClient)

include(CheckIncludeFileCXX)
CHECK_INCLUDE_FILE_CXX("filesystem" HAVE_STD_FILESYSTEM)

if (HAVE_STD_FILESYSTEM)
  add_executable(media_downloader media_downloader.cpp)
  target_link_libraries(media_downloader MatrixClient::MatrixClient)
endif()

add_executable(simple_bot simple_bot.cpp)
target_link_libraries(simple_bot MatrixClient::MatrixClient)

add_executable(crypto_bot crypto_bot.cpp)
target_link_libraries(crypto_bot
                      spdlog::spdlog
                      MatrixClient::MatrixClient
                      Olm::Olm)

=== debian/changelog ===
nheko (0.8.0+really0.7.2-4) unstable; urgency=medium

  * debian/control, patches/no_tweeny:
    * Don't use tweeny, to avoid a compiler error in gcc-10. (Closes: #986519)

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 15 Apr 2021 17:10:18 -0400

=== debian/control ===
Source: nheko
Section: net
Priority: optional
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
Uploaders: Hubert Chathi <uhoreg@debian.org>
Build-Depends: cmake (>= 3.15)
 , debhelper-compat (=12)
 , dh-exec
 , libboost-dev (>= 1.70)
 , libboost-atomic-dev (>= 1.70)
 , libboost-chrono-dev (>= 1.70)
 , libboost-date-time-dev (>= 1.70)
 , libboost-iostreams-dev (>= 1.70)
 , libboost-random-dev (>= 1.70)
 , libboost-regex-dev (>= 1.70)
 , libboost-system-dev (>= 1.70)
 , libboost-thread-dev (>= 1.70)
 , libcmark-dev (>= 0.29)
 , liblmdb++-dev
 , libolm-dev (>= 3.0~)
 , libqt5svg5-dev
 , libspdlog-dev (>= 1.5.0+ds-4)
 , libsodium-dev
 , libssl-dev
 , nlohmann-json3-dev (>= 3.7.0-2~)
 , qtbase5-dev (>= 5.10)
 , qtdeclarative5-dev
 , libfmt-dev
 , qtquickcontrols2-5-dev
 , qtmultimedia5-dev
 , qttools5-dev
 , zlib1g-dev
Standards-Version: 4.5.0
Homepage: https://github.com/Nheko-Reborn/nheko
Vcs-Git: https://salsa.debian.org/matrix-team/nheko.git
Vcs-Browser: https://salsa.debian.org/matrix-team/nheko

Package: nheko
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
 , qml-module-qt-labs-settings
 , qml-module-qtgraphicaleffects
 , qml-module-qtmultimedia
 , qml-module-qtquick2
 , qml-module-qtquick-controls2
 , qml-module-qtquick-layouts
 , qml-module-qtquick-window2
Recommends: ca-certificates, fonts-noto-color-emoji
Description: desktop IM client for the Matrix protocol
 Nheko is a Qt-based chat client for Matrix, an open, federated communications
 protocol.  The motivation behind the project is to provide a native desktop
 app for Matrix that feels more like a mainstream chat app and less like an IRC
 client.

=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS) $(FMTFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) $(FMTFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS) $(FMTFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export QT_SELECT=5

%:
	dh $@ 

# set $HOME to a dummy directory, because cmake tries to write stuff to $HOME
override_dh_auto_build: FAKEHOME = HOME=$(CURDIR)/fakehome
override_dh_auto_build:
	[ -d fakehome ] || mkdir fakehome
	$(FAKEHOME) dh_auto_configure --sourcedirectory=mtxclient --builddirectory=.deps -- -DCMAKE_VERBOSE_MAKEFILE=ON -DBUILD_LIB_TESTS=OFF -DBUILD_SHARED_LIBS=OFF -DBUILD_LIB_EXAMPLES=OFF
	$(FAKEHOME) dh_auto_build --sourcedirectory=mtxclient --builddirectory=.deps
	$(FAKEHOME) dh_auto_configure --builddirectory=build -- -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_PREFIX_PATH=.deps -DCMAKE_INSTALL_PREFIX=.deps/usr -DCMAKE_VERBOSE_MAKEFILE=ON -DBUILD_LIB_EXAMPLES=OFF
	$(FAKEHOME) dh_auto_build --builddirectory=build
	rm -rf fakehome

override_dh_auto_test:
	#

override_dh_auto_clean:
	rm -rf .deps build fakehome

make-orig-source: VERSION = `dpkg-parsechangelog | grep ^Version | sed 's/Version: \(.*\)-[^-]*/\1/'`
make-orig-source:
	tar czf ../nheko_$(VERSION).orig.tar.gz --exclude-vcs --exclude-backups --exclude /debian --exclude /mtxclient -C .. `basename $(CURDIR)`
	tar czf ../nheko_$(VERSION).orig-mtxclient.tar.gz --exclude-vcs --exclude-backups mtxclient

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/Nheko-reborn/nheko/tags \
   (?:.*?/)?v(\d[\d.]*)\.tar\.gz debian uupdate

## nheko 0.9.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

option(APPVEYOR_BUILD "Build on appveyor" OFF)
option(CI_BUILD "Set when building in CI. Enables -Werror where possible" OFF)
option(ASAN "Compile with address sanitizers" OFF)
option(QML_DEBUGGING "Enable qml debugging" OFF)
option(COMPILE_QML "Compile Qml. It will make Nheko faster, but you will need to recompile it, when you update Qt." OFF)

set(
	CMAKE_TOOLCHAIN_FILE "${CMAKE_CURRENT_LIST_DIR}/toolchain.cmake"
	CACHE
	FILEPATH "Default toolchain"
	)
set(CMAKE_CXX_STANDARD 17 CACHE STRING "C++ standard")
set(CMAKE_CXX_STANDARD_REQUIRED ON CACHE BOOL "Require C++ standard to be supported")
set(CMAKE_POSITION_INDEPENDENT_CODE ON CACHE BOOL "compile as PIC by default")

option(HUNTER_ENABLED "Enable Hunter package manager" OFF)
include("cmake/HunterGate.cmake")
HunterGate(
	URL "https://github.com/cpp-pm/hunter/archive/v0.23.305.tar.gz"
	SHA1 "fc8d7a6dac2fa23681847b3872d88d3839b657b0"
	LOCAL
	)

macro(hunter_add_package_safe)
	set(pkg_temp_backup_libdir "$ENV{PKG_CONFIG_LIBDIR}")
	set(pkg_temp_backup_path "$ENV{PKG_CONFIG_PATH}")
	hunter_add_package(${ARGV})
	if("${pkg_temp_backup_path}" STREQUAL "")
		unset(ENV{PKG_CONFIG_PATH})
	else()
		set(ENV{PKG_CONFIG_PATH} "${pkg_temp_backup_path}")
	endif()
	if("${pkg_temp_backup_libdir}" STREQUAL "")
		unset(ENV{PKG_CONFIG_LIBDIR})
	else()
		set(ENV{PKG_CONFIG_LIBDIR} "${pkg_temp_backup_libdir}")
	endif()
	message("pkg_conf_path: '$ENV{PKG_CONFIG_PATH}', pkg_conf_libdir: '$ENV{PKG_CONFIG_LIBDIR}'")
endmacro()

option(USE_BUNDLED_SPDLOG "Use the bundled version of spdlog." ${HUNTER_ENABLED})
option(USE_BUNDLED_OLM "Use the bundled version of libolm." ${HUNTER_ENABLED})
option(USE_BUNDLED_GTEST "Use the bundled version of Google Test." ${HUNTER_ENABLED})
option(USE_BUNDLED_CMARK "Use the bundled version of cmark." ${HUNTER_ENABLED})
option(USE_BUNDLED_JSON "Use the bundled version of nlohmann json." ${HUNTER_ENABLED})
option(USE_BUNDLED_OPENSSL "Use the bundled version of OpenSSL." OFF)
option(USE_BUNDLED_MTXCLIENT "Use the bundled version of the Matrix Client library." ${HUNTER_ENABLED})
option(USE_BUNDLED_LMDB "Use the bundled version of lmdb." ${HUNTER_ENABLED})
option(USE_BUNDLED_LMDBXX "Use the bundled version of lmdb++." ${HUNTER_ENABLED})
option(USE_BUNDLED_QTKEYCHAIN "Use the bundled version of Qt5Keychain." ${HUNTER_ENABLED})
option(USE_BUNDLED_COEURL "Use a bundled version of the Curl wrapper"
	${HUNTER_ENABLED})
option(USE_BUNDLED_LIBEVENT "Use the bundled version of spdlog." ${HUNTER_ENABLED})
option(USE_BUNDLED_LIBCURL "Use the bundled version of spdlog." ${HUNTER_ENABLED})

include(CMakeDependentOption)
set(VOIP_DEFAULT ON)
if (APPLE OR WIN32)
	set(VOIP_DEFAULT OFF)
endif()
option(VOIP "Whether to enable voip support. Disable this, if you don't have gstreamer." ${VOIP_DEFAULT})
cmake_dependent_option(SCREENSHARE_X11 "Whether to enable screenshare support on X11." ON "VOIP" OFF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

if(${CMAKE_VERSION} VERSION_LESS "3.14.0")
	message("Adding FetchContent_MakeAvailable")
	# from cmakes sources
	macro(FetchContent_MakeAvailable)

		foreach(contentName IN ITEMS ${ARGV})
			string(TOLOWER ${contentName} contentNameLower)
			FetchContent_GetProperties(${contentName})
			if(NOT ${contentNameLower}_POPULATED)
				FetchContent_Populate(${contentName})

				# Only try to call add_subdirectory() if the populated content
				# can be treated that way. Protecting the call with the check
				# allows this function to be used for projects that just want
				# to ensure the content exists, such as to provide content at
				# a known location.
				if(EXISTS ${${contentNameLower}_SOURCE_DIR}/CMakeLists.txt)
					add_subdirectory(${${contentNameLower}_SOURCE_DIR}
						${${contentNameLower}_BINARY_DIR})
				endif()
			endif()
		endforeach()

	endmacro()
endif()

# Include Qt basic functions
include(QtCommon)

project(nheko LANGUAGES CXX C)

include(GNUInstallDirs)

set(CPACK_PACKAGE_VERSION_MAJOR "0")
set(CPACK_PACKAGE_VERSION_MINOR "9")
set(CPACK_PACKAGE_VERSION_PATCH "1")
set(PROJECT_VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH})

# Set PROJECT_VERSION_PATCH & PROJECT_VERSION_TWEAK to 0 if not present
# Needed by add_project_meta.
fix_project_version()

# Set additional project information
set(COMPANY "Nheko")
set(COPYRIGHT "Copyright (c) 2021 Nheko Contributors")
set(IDENTIFIER "io.github.nheko-reborn.nheko")

add_project_meta(META_FILES_TO_INCLUDE)

if(NOT MSVC AND NOT APPLE)
	set(THREADS_PREFER_PTHREAD_FLAG ON)
	find_package(Threads REQUIRED)
endif()

if (BUILD_DOCS)
	find_package(Doxygen)

	if (DOXYGEN_FOUND)
		set(DOXYGEN_IN ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Doxyfile.in)
		set(DOXYGEN_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

		configure_file(${DOXYGEN_IN} ${DOXYGEN_OUT})

		add_custom_target(docs ALL
			COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_OUT}
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			COMMENT "Generating API documentation with Doxygen"
			VERBATIM )
	else (DOXYGEN_FOUND)
		message("Doxygen need to be installed to generate the doxygen documentation")
	endif (DOXYGEN_FOUND)
endif()

#
## coeurl
#
## Need to repeat all libevent deps?!?
if (USE_BUNDLED_LIBEVENT)
	hunter_add_package_safe(Libevent)
	find_package(Libevent CONFIG REQUIRED)
else()
	find_package(PkgConfig REQUIRED) 
	pkg_check_modules(libevent_core REQUIRED IMPORTED_TARGET libevent_core)
	if (WIN32)
		pkg_check_modules(libevent_windows REQUIRED IMPORTED_TARGET libevent_windows)
	else()
		pkg_check_modules(libevent_pthreads REQUIRED IMPORTED_TARGET
			libevent_pthreads)
	endif()
endif()

# curl
if (USE_BUNDLED_LIBCURL)
	hunter_add_package_safe(CURL)
	find_package(CURL CONFIG REQUIRED)
else()
	find_package(PkgConfig REQUIRED) 
	pkg_check_modules(libcurl REQUIRED IMPORTED_TARGET libcurl)
endif()

# spdlog
if(USE_BUNDLED_SPDLOG)
	hunter_add_package_safe(spdlog)
endif()
find_package(spdlog 1.0.0 CONFIG REQUIRED)

#
# LMDB
#
#include(LMDB)
if(USE_BUNDLED_LMDB)
	hunter_add_package_safe(lmdb)
	find_package(liblmdb CONFIG REQUIRED)

	target_include_directories(liblmdb::lmdb INTERFACE
		"${HUNTER_INSTALL_PREFIX}/include/lmdb")
else()
	find_package(LMDB REQUIRED)
endif()

#
# Discover Qt dependencies.
#
find_package(Qt5 5.15 COMPONENTS Core Widgets LinguistTools Concurrent Svg Multimedia Qml QuickControls2 QuickWidgets REQUIRED)
find_package(Qt5QuickCompiler)
find_package(Qt5DBus)

if (USE_BUNDLED_QTKEYCHAIN)
	include(FetchContent)
	FetchContent_Declare(
		qt5keychain
		GIT_REPOSITORY https://github.com/frankosterfeld/qtkeychain.git
		GIT_TAG        v0.13.1
		)
	if (BUILD_SHARED_LIBS)
		set(QTKEYCHAIN_STATIC OFF CACHE INTERNAL "")
	else()
		set(QTKEYCHAIN_STATIC ON CACHE INTERNAL "")
	endif()
	set(BUILD_TEST_APPLICATION OFF CACHE INTERNAL "")
	FetchContent_MakeAvailable(qt5keychain)
else()
	find_package(Qt5Keychain REQUIRED)
endif()

if (APPLE)
	find_package(Qt5MacExtras REQUIRED)
endif(APPLE)

if (Qt5Widgets_FOUND)
	if (Qt5Widgets_VERSION VERSION_LESS 5.15.0)
		message(STATUS "Qt version ${Qt5Widgets_VERSION}")
		message(WARNING "Minimum supported Qt5 version is 5.15!")
	endif()
endif(Qt5Widgets_FOUND)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
if(NOT MSVC)
	set(
		CMAKE_CXX_FLAGS
		"${CMAKE_CXX_FLAGS} \
		-Wall \
		-Wextra \
		-pipe \
		-pedantic \
		-fsized-deallocation \
		-fdiagnostics-color=always \
		-Wunreachable-code \
		-Wno-attributes"
		)
	if (NOT CMAKE_COMPILER_IS_GNUCXX)
		# -Wshadow is buggy and broken in GCC, so do not enable it.
		# see https://gcc.gnu.org/bugzilla/show_bug.cgi?id=79328
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow")
	endif()
endif()

if (MSVC)
	set(
		CMAKE_CXX_FLAGS
		"${CMAKE_CXX_FLAGS} /bigobj"
		)
endif()

if(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))
	set(CMAKE_BUILD_TYPE "Debug" CACHE STRING
		"Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
		FORCE)
	message("Setting build type to '${CMAKE_BUILD_TYPE}'")
else(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))
	message("Build type set to '${CMAKE_BUILD_TYPE}'")
endif(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))

set(SPDLOG_DEBUG_ON false)

# Windows doesn't handle CMAKE_BUILD_TYPE.
if(NOT WIN32)
	if(CMAKE_BUILD_TYPE STREQUAL "Debug")
		set(SPDLOG_DEBUG_ON true)
	else()
		set(SPDLOG_DEBUG_ON false)
	endif()
endif()

find_program(GIT git)
if(GIT)
	execute_process(
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		COMMAND ${GIT} rev-parse --short HEAD
		OUTPUT_VARIABLE GIT_OUT OUTPUT_STRIP_TRAILING_WHITESPACE
		)
	if(GIT_OUT)
		set(CPACK_PACKAGE_VERSION_PATCH "${CPACK_PACKAGE_VERSION_PATCH}-${GIT_OUT}")
	else()
		set(CPACK_PACKAGE_VERSION_PATCH "${CPACK_PACKAGE_VERSION_PATCH}")
	endif()
endif(GIT)

set(CPACK_PACKAGE_VERSION ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH})
set(PROJECT_VERSION ${CPACK_PACKAGE_VERSION})

message(STATUS "Version: ${PROJECT_VERSION}")

cmake_host_system_information(RESULT BUILD_HOST QUERY HOSTNAME)

include(CheckSymbolExists)
check_symbol_exists(backtrace_symbols_fd "execinfo.h" HAVE_BACKTRACE_SYMBOLS_FD)

configure_file(cmake/nheko.h config/nheko.h)


#
# Declare source and header files.
#
set(SRC_FILES
	# Dialogs
	src/dialogs/CreateRoom.cpp
	src/dialogs/FallbackAuth.cpp
	src/dialogs/ImageOverlay.cpp
	src/dialogs/Logout.cpp
	src/dialogs/PreviewUploadOverlay.cpp
	src/dialogs/ReCaptcha.cpp

	# Emoji
	src/emoji/EmojiModel.cpp
	src/emoji/Provider.cpp


	# Timeline
	src/timeline/CommunitiesModel.cpp
	src/timeline/EventStore.cpp
	src/timeline/InputBar.cpp
	src/timeline/Reaction.cpp
	src/timeline/TimelineViewManager.cpp
	src/timeline/TimelineModel.cpp
	src/timeline/DelegateChooser.cpp
	src/timeline/Permissions.cpp
	src/timeline/RoomlistModel.cpp

	# UI components
	src/ui/Badge.cpp
	src/ui/DropShadow.cpp
	src/ui/FlatButton.cpp
	src/ui/FloatingButton.cpp
	src/ui/InfoMessage.cpp
	src/ui/Label.cpp
	src/ui/LoadingIndicator.cpp
	src/ui/MxcAnimatedImage.cpp
	src/ui/MxcMediaProxy.cpp
	src/ui/NhekoCursorShape.cpp
	src/ui/NhekoDropArea.cpp
	src/ui/NhekoGlobalObject.cpp
	src/ui/OverlayModal.cpp
	src/ui/OverlayWidget.cpp
	src/ui/RaisedButton.cpp
	src/ui/Ripple.cpp
	src/ui/RippleOverlay.cpp
	src/ui/RoomSettings.cpp
	src/ui/SnackBar.cpp
	src/ui/TextField.cpp
	src/ui/TextLabel.cpp
	src/ui/Theme.cpp
	src/ui/ThemeManager.cpp
	src/ui/ToggleButton.cpp
	src/ui/UIA.cpp
	src/ui/UserProfile.cpp

	src/voip/CallDevices.cpp
	src/voip/CallManager.cpp
	src/voip/WebRTCSession.cpp

	src/encryption/DeviceVerificationFlow.cpp
	src/encryption/Olm.cpp
	src/encryption/SelfVerificationStatus.cpp
	src/encryption/VerificationManager.cpp

	# Generic notification stuff
	src/notifications/Manager.cpp

	src/AvatarProvider.cpp
	src/BlurhashProvider.cpp
	src/Cache.cpp
	src/ChatPage.cpp
	src/Clipboard.cpp
	src/ColorImageProvider.cpp
	src/CompletionProxyModel.cpp
	src/EventAccessors.cpp
	src/InviteesModel.cpp
	src/JdenticonProvider.cpp
	src/Logging.cpp
	src/LoginPage.cpp
	src/MainWindow.cpp
	src/MatrixClient.cpp
	src/MemberList.cpp
	src/MxcImageProvider.cpp
	src/ReadReceiptsModel.cpp
	src/RegisterPage.cpp
	src/SSOHandler.cpp
	src/CombinedImagePackModel.cpp
	src/SingleImagePackModel.cpp
	src/ImagePackListModel.cpp
	src/TrayIcon.cpp
	src/UserSettingsPage.cpp
	src/UsersModel.cpp
	src/RoomDirectoryModel.cpp
	src/RoomsModel.cpp
	src/Utils.cpp
	src/WelcomePage.cpp
	src/main.cpp

	third_party/blurhash/blurhash.cpp
	)


include(FeatureSummary)


if(USE_BUNDLED_OPENSSL)
	hunter_add_package_safe(OpenSSL)
endif()
find_package(OpenSSL 1.1.0 REQUIRED)
if(USE_BUNDLED_MTXCLIENT)
	include(FetchContent)
	FetchContent_Declare(
		MatrixClient
		GIT_REPOSITORY https://github.com/Nheko-Reborn/mtxclient.git
		GIT_TAG        v0.6.1
		)
	set(BUILD_LIB_EXAMPLES OFF CACHE INTERNAL "")
	set(BUILD_LIB_TESTS OFF CACHE INTERNAL "")
	FetchContent_MakeAvailable(MatrixClient)
else()
	find_package(MatrixClient 0.6.1 REQUIRED)
endif()

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 FILES=`find lib include tests examples -type f -type f \( -iname "*.cpp" -o -iname "*.hpp" \)`
 
-SYNAPSE_IMAGE="matrixdotorg/synapse:v1.7.2"
+SYNAPSE_IMAGE="matrixdotorg/synapse:v1.44.0"
 
 DEPS_BUILD_DIR=.deps
 DEPS_SOURCE_DIR=deps

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,13 @@
 if (HAVE_STD_FILESYSTEM)
   add_executable(media_downloader media_downloader.cpp)
   target_link_libraries(media_downloader MatrixClient::MatrixClient)
+  if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
+    target_link_libraries(media_downloader stdc++fs)
+  endif()
 endif()
+
+add_executable(memberstats memberstats.cpp)
+target_link_libraries(memberstats MatrixClient::MatrixClient)
 
 add_executable(simple_bot simple_bot.cpp)
 target_link_libraries(simple_bot MatrixClient::MatrixClient)
@@ -29,3 +35,6 @@
                       spdlog::spdlog
                       MatrixClient::MatrixClient
                       Olm::Olm)
+
+  add_executable(online_backup_exporter online_backup_exporter.cpp)
+  target_link_libraries(online_backup_exporter MatrixClient::MatrixClient)

=== third_party/SingleApplication-3.3.2/examples/basic/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7.0)

project(basic LANGUAGES CXX)

# SingleApplication base class
set(QAPPLICATION_CLASS QCoreApplication)
add_subdirectory(../.. SingleApplication)

add_executable(basic main.cpp)

target_link_libraries(${PROJECT_NAME} SingleApplication::SingleApplication)

=== debian/changelog ===
nheko (0.9.1-1) unstable; urgency=medium

  * New upstream release.

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 22 Feb 2022 19:15:22 -0500

nheko (0.9.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/disambiguate_olmerrorcode: removed -- no longer needed.

 -- Hubert Chathi <uhoreg@debian.org>  Fri, 03 Dec 2021 14:18:39 -0500

nheko (0.8.2-2) unstable; urgency=medium

  * debian/control: Add missing QML dependency. (Closes: #990351)
  * debian/patches/disambiguate_olmerrorcode: Fix build with newer libolm.

 -- Hubert Chathi <uhoreg@debian.org>  Sat, 16 Oct 2021 14:42:04 -0400

nheko (0.8.2-1) experimental; urgency=medium

  [ Pirate Praveen ]

  * debian/control: Add missing gstreamer dependencies. (Closes: #981104)

  [ Hubert Chathi ]

  * New upstream release. (Closes: #981525)
  * debian/control: update with new build-depends
  * debian/patches/no_find_tweeny: removed -- not needed any more.

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 11 May 2021 16:26:27 -0400

nheko (0.8.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    * add build-depends on gstreamer

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 20 Jan 2021 14:07:37 -0500

=== debian/control ===
--- 
+++ 
@@ -6,23 +6,22 @@
 Build-Depends: cmake (>= 3.15)
  , debhelper-compat (=12)
  , dh-exec
- , libboost-dev (>= 1.70)
- , libboost-atomic-dev (>= 1.70)
- , libboost-chrono-dev (>= 1.70)
- , libboost-date-time-dev (>= 1.70)
- , libboost-iostreams-dev (>= 1.70)
- , libboost-random-dev (>= 1.70)
- , libboost-regex-dev (>= 1.70)
- , libboost-system-dev (>= 1.70)
- , libboost-thread-dev (>= 1.70)
  , libcmark-dev (>= 0.29)
- , liblmdb++-dev
+ , libcurl4-openssl-dev
+ , libevent-dev
+ , libgstreamer1.0-dev (>= 1.18.0)
+ , libgstreamer-plugins-base1.0-dev (>= 1.18.0)
+ , libgstreamer-plugins-bad1.0-dev (>= 1.18.0)
+ , liblmdb-dev
+ , libnice-dev
  , libolm-dev (>= 3.0~)
  , libqt5svg5-dev
  , libspdlog-dev (>= 1.5.0+ds-4)
  , libsodium-dev
  , libssl-dev
+ , libxcb-ewmh-dev
  , nlohmann-json3-dev (>= 3.7.0-2~)
+ , qt5keychain-dev
  , qtbase5-dev (>= 5.10)
  , qtdeclarative5-dev
  , libfmt-dev
@@ -38,6 +37,7 @@
 Package: nheko
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+ , qml-module-qt-labs-platform
  , qml-module-qt-labs-settings
  , qml-module-qtgraphicaleffects
  , qml-module-qtmultimedia
@@ -45,6 +45,9 @@
  , qml-module-qtquick-controls2
  , qml-module-qtquick-layouts
  , qml-module-qtquick-window2
+ , gstreamer1.0-nice
+ , gstreamer1.0-qt5
+ , gstreamer1.0-vaapi
 Recommends: ca-certificates, fonts-noto-color-emoji
 Description: desktop IM client for the Matrix protocol
  Nheko is a Qt-based chat client for Matrix, an open, federated communications

=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS) $(FMTFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) $(FMTFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS) $(FMTFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export QT_SELECT=5

%:
	dh $@ 

# set $HOME to a dummy directory, because cmake tries to write stuff to $HOME
override_dh_auto_build: FAKEHOME = HOME=$(CURDIR)/fakehome
override_dh_auto_build:
	[ -d fakehome ] || mkdir fakehome
	$(FAKEHOME) dh_auto_configure --sourcedirectory=coeurl --builddirectory=.deps/coeurl --  -DCMAKE_VERBOSE_MAKEFILE=ON
	cd .deps/coeurl && make
	$(FAKEHOME) dh_auto_configure --sourcedirectory=mtxclient --builddirectory=.deps/mtxclient -- -DCMAKE_VERBOSE_MAKEFILE=ON -DBUILD_LIB_TESTS=OFF -DBUILD_SHARED_LIBS=OFF -DBUILD_LIB_EXAMPLES=OFF -Dcoeurl_DIR=$(CURDIR)/.deps/coeurl
	$(FAKEHOME) dh_auto_build --sourcedirectory=mtxclient --builddirectory=.deps/mtxclient
	$(FAKEHOME) dh_auto_configure --builddirectory=build -- -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_VERBOSE_MAKEFILE=ON -DBUILD_LIB_EXAMPLES=OFF -DLMDBXX_INCLUDE_DIR=$(CURDIR)/lmdbxx -Dcoeurl_DIR=$(CURDIR)/.deps/coeurl -DMatrixClient_DIR=$(CURDIR)/.deps/mtxclient
	$(FAKEHOME) dh_auto_build --builddirectory=build
	rm -rf fakehome

override_dh_auto_test:
	#

override_dh_auto_clean:
	rm -rf .deps build fakehome

make-orig-source: VERSION = `dpkg-parsechangelog | grep ^Version | sed 's/Version: \(.*\)-[^-]*/\1/'`
make-orig-source:
	tar czf ../nheko_$(VERSION).orig.tar.gz --exclude-vcs --exclude-backups --exclude /debian --exclude /mtxclient /lmdbxx -C .. `basename $(CURDIR)`
	tar czf ../nheko_$(VERSION).orig-mtxclient.tar.gz --exclude-vcs --exclude-backups mtxclient
	tar czf ../nheko_$(VERSION).orig-lmdbxx.tar.gz --exclude-vcs --exclude-backups lmdbxx

## nheko 0.9.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,12 @@
 option(ASAN "Compile with address sanitizers" OFF)
 option(QML_DEBUGGING "Enable qml debugging" OFF)
 option(COMPILE_QML "Compile Qml. It will make Nheko faster, but you will need to recompile it, when you update Qt." OFF)
+if(UNIX AND NOT APPLE)
+	option(MAN "Build man page" ON)
+else()
+	option(MAN "Build man page" OFF)
+endif()
+option(FLATPAK "Set this only if Nheko is built as a flatpak" OFF)
 
 set(
 	CMAKE_TOOLCHAIN_FILE "${CMAKE_CURRENT_LIST_DIR}/toolchain.cmake"
@@ -100,7 +106,7 @@
 
 set(CPACK_PACKAGE_VERSION_MAJOR "0")
 set(CPACK_PACKAGE_VERSION_MINOR "9")
-set(CPACK_PACKAGE_VERSION_PATCH "1")
+set(CPACK_PACKAGE_VERSION_PATCH "3")
 set(PROJECT_VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR})
 set(PROJECT_VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR})
 set(PROJECT_VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH})
@@ -111,7 +117,7 @@
 
 # Set additional project information
 set(COMPANY "Nheko")
-set(COPYRIGHT "Copyright (c) 2021 Nheko Contributors")
+set(COPYRIGHT "Copyright (c) 2022 Nheko Contributors")
 set(IDENTIFIER "io.github.nheko-reborn.nheko")
 
 add_project_meta(META_FILES_TO_INCLUDE)
@@ -305,9 +311,6 @@
 	# Dialogs
 	src/dialogs/CreateRoom.cpp
 	src/dialogs/FallbackAuth.cpp
-	src/dialogs/ImageOverlay.cpp
-	src/dialogs/Logout.cpp
-	src/dialogs/PreviewUploadOverlay.cpp
 	src/dialogs/ReCaptcha.cpp
 
 	# Emoji
@@ -324,30 +327,19 @@
 	src/timeline/TimelineModel.cpp
 	src/timeline/DelegateChooser.cpp
 	src/timeline/Permissions.cpp
+	src/timeline/PresenceEmitter.cpp
 	src/timeline/RoomlistModel.cpp
 
 	# UI components
-	src/ui/Badge.cpp
-	src/ui/DropShadow.cpp
-	src/ui/FlatButton.cpp
-	src/ui/FloatingButton.cpp
-	src/ui/InfoMessage.cpp
-	src/ui/Label.cpp
-	src/ui/LoadingIndicator.cpp
+	src/ui/HiddenEvents.cpp
 	src/ui/MxcAnimatedImage.cpp
 	src/ui/MxcMediaProxy.cpp
 	src/ui/NhekoCursorShape.cpp
+	src/ui/NhekoEventObserver.cpp
 	src/ui/NhekoDropArea.cpp
 	src/ui/NhekoGlobalObject.cpp
-	src/ui/OverlayModal.cpp
-	src/ui/OverlayWidget.cpp
-	src/ui/RaisedButton.cpp
-	src/ui/Ripple.cpp
-	src/ui/RippleOverlay.cpp
 	src/ui/RoomSettings.cpp
-	src/ui/SnackBar.cpp
 	src/ui/TextField.cpp
-	src/ui/TextLabel.cpp
 	src/ui/Theme.cpp
 	src/ui/ThemeManager.cpp
 	src/ui/ToggleButton.cpp
@@ -394,7 +386,6 @@
 	src/RoomDirectoryModel.cpp
 	src/RoomsModel.cpp
 	src/Utils.cpp
-	src/WelcomePage.cpp
 	src/main.cpp
 
 	third_party/blurhash/blurhash.cpp
@@ -413,11 +404,18 @@
 	FetchContent_Declare(
 		MatrixClient
 		GIT_REPOSITORY https://github.com/Nheko-Reborn/mtxclient.git
-		GIT_TAG        v0.6.1
+		GIT_TAG        v0.7.0
 		)
 	set(BUILD_LIB_EXAMPLES OFF CACHE INTERNAL "")
 	set(BUILD_LIB_TESTS OFF CACHE INTERNAL "")
 	FetchContent_MakeAvailable(MatrixClient)
 else()
-	find_package(MatrixClient 0.6.1 REQUIRED)
-endif()
+	find_package(MatrixClient 0.6.2 REQUIRED)
+endif()
+if(USE_BUNDLED_OLM)
+	include(FetchContent)
+	FetchContent_Declare(
+		Olm
+		GIT_REPOSITORY https://gitlab.matrix.org/matrix-org/olm.git
+		GIT_TAG        3.2.8
+		)

=== debian/changelog ===
nheko (0.9.3-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Pirate Praveen <praveen@debian.org>  Fri, 24 Jun 2022 19:54:56 +0530

nheko (0.9.3-2) unstable; urgency=medium

  * debian/control: Add some missing dependencies.  Thanks to Pablo Barciela.

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 08 Jun 2022 10:34:29 -0400

nheko (0.9.3-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Pirate Praveen <praveen@debian.org>  Fri, 17 Jun 2022 12:10:08 +0530

nheko (0.9.3-1) unstable; urgency=medium

  * New upstream release.

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 07 Jun 2022 13:23:39 -0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: optional
 Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
 Uploaders: Hubert Chathi <uhoreg@debian.org>
-Build-Depends: cmake (>= 3.15)
+Build-Depends: asciidoc-base
+ , cmake (>= 3.15)
  , debhelper-compat (=12)
  , dh-exec
  , libcmark-dev (>= 0.29)
@@ -37,6 +38,8 @@
 Package: nheko
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+ , libqt5multimedia5-plugins
+ , qml-module-qt-labs-animation
  , qml-module-qt-labs-platform
  , qml-module-qt-labs-settings
  , qml-module-qtgraphicaleffects
